/* Generated by CIL v. 1.5.1 */
/* print_CIL_Input is false */

#line 26 "include/uapi/asm-generic/int-ll64.h"
typedef unsigned int __u32;
#line 16 "include/asm-generic/int-ll64.h"
typedef unsigned char u8;
#line 19 "include/asm-generic/int-ll64.h"
typedef unsigned short u16;
#line 22 "include/asm-generic/int-ll64.h"
typedef unsigned int u32;
#line 25 "include/asm-generic/int-ll64.h"
typedef unsigned long long u64;
#line 177 "include/linux/types.h"
struct __anonstruct_atomic_t_6 {
   int counter ;
};
#line 177 "include/linux/types.h"
typedef struct __anonstruct_atomic_t_6 atomic_t;
#line 183 "include/linux/types.h"
struct list_head {
   struct list_head *next ;
   struct list_head *prev ;
};
#line 67 "./arch/x86/include/asm/page_types.h"
struct pt_regs {
   unsigned long r15 ;
   unsigned long r14 ;
   unsigned long r13 ;
   unsigned long r12 ;
   unsigned long bp ;
   unsigned long bx ;
   unsigned long r11 ;
   unsigned long r10 ;
   unsigned long r9 ;
   unsigned long r8 ;
   unsigned long ax ;
   unsigned long cx ;
   unsigned long dx ;
   unsigned long si ;
   unsigned long di ;
   unsigned long orig_ax ;
   unsigned long ip ;
   unsigned long cs ;
   unsigned long flags ;
   unsigned long sp ;
   unsigned long ss ;
};
#line 66 "./arch/x86/include/asm/ptrace.h"
struct __anonstruct____missing_field_name_9 {
   unsigned int a ;
   unsigned int b ;
};
#line 66 "./arch/x86/include/asm/ptrace.h"
struct __anonstruct____missing_field_name_10 {
   u16 limit0 ;
   u16 base0 ;
   unsigned char base1 ;
   unsigned char type : 4 ;
   unsigned char s : 1 ;
   unsigned char dpl : 2 ;
   unsigned char p : 1 ;
   unsigned char limit : 4 ;
   unsigned char avl : 1 ;
   unsigned char l : 1 ;
   unsigned char d : 1 ;
   unsigned char g : 1 ;
   unsigned char base2 ;
};
#line 66 "./arch/x86/include/asm/ptrace.h"
union __anonunion____missing_field_name_8 {
   struct __anonstruct____missing_field_name_9 __annonCompField4 ;
   struct __anonstruct____missing_field_name_10 __annonCompField5 ;
};
#line 66 "./arch/x86/include/asm/ptrace.h"
struct desc_struct {
   union __anonunion____missing_field_name_8 __annonCompField6 ;
};
#line 43 "./arch/x86/include/asm/desc_defs.h"
struct gate_struct64 {
   u16 offset_low ;
   u16 segment ;
   unsigned char ist : 3 ;
   unsigned char zero0 : 5 ;
   unsigned char type : 5 ;
   unsigned char dpl : 2 ;
   unsigned char p : 1 ;
   u16 offset_middle ;
   u32 offset_high ;
   u32 zero1 ;
};
#line 81 "./arch/x86/include/asm/desc_defs.h"
typedef struct gate_struct64 gate_desc;
#line 84 "./arch/x86/include/asm/desc_defs.h"
struct desc_ptr {
   unsigned short size ;
   unsigned long address ;
};
#line 423 "./arch/x86/include/asm/pgtable_types.h"
struct thread_struct;
#line 424
struct tss_struct;
#line 426
struct task_struct;
#line 102 "./arch/x86/include/asm/paravirt_types.h"
struct pv_cpu_ops {
   unsigned long (*get_debugreg)(int  ) ;
   void (*set_debugreg)(int  , unsigned long  ) ;
   void (*clts)(void) ;
   unsigned long (*read_cr0)(void) ;
   void (*write_cr0)(unsigned long  ) ;
   unsigned long (*read_cr4_safe)(void) ;
   unsigned long (*read_cr4)(void) ;
   void (*write_cr4)(unsigned long  ) ;
   unsigned long (*read_cr8)(void) ;
   void (*write_cr8)(unsigned long  ) ;
   void (*load_tr_desc)(void) ;
   void (*load_gdt)(struct desc_ptr  const  * ) ;
   void (*load_idt)(struct desc_ptr  const  * ) ;
   void (*store_idt)(struct desc_ptr * ) ;
   void (*set_ldt)(void const   * , unsigned int  ) ;
   unsigned long (*store_tr)(void) ;
   void (*load_tls)(struct thread_struct * , unsigned int  ) ;
   void (*load_gs_index)(unsigned int  ) ;
   void (*write_ldt_entry)(struct desc_struct * , int  , void const   * ) ;
   void (*write_gdt_entry)(struct desc_struct * , int  , void const   * , int  ) ;
   void (*write_idt_entry)(gate_desc * , int  , gate_desc const   * ) ;
   void (*alloc_ldt)(struct desc_struct * , unsigned int  ) ;
   void (*free_ldt)(struct desc_struct * , unsigned int  ) ;
   void (*load_sp0)(struct tss_struct * , struct thread_struct * ) ;
   void (*set_iopl_mask)(unsigned int  ) ;
   void (*wbinvd)(void) ;
   void (*io_delay)(void) ;
   void (*cpuid)(unsigned int * , unsigned int * , unsigned int * , unsigned int * ) ;
   u64 (*read_msr)(unsigned int  , int * ) ;
   int (*write_msr)(unsigned int  , unsigned int  , unsigned int  ) ;
   u64 (*read_tsc)(void) ;
   u64 (*read_pmc)(int  ) ;
   unsigned long long (*read_tscp)(unsigned int * ) ;
   void (*usergs_sysret64)(void) ;
   void (*usergs_sysret32)(void) ;
   void (*iret)(void) ;
   void (*swapgs)(void) ;
   void (*start_context_switch)(struct task_struct * ) ;
   void (*end_context_switch)(struct task_struct * ) ;
};
#line 20 "./arch/x86/include/asm/spinlock_types.h"
struct qspinlock {
   atomic_t val ;
};
#line 33 "include/asm-generic/qspinlock_types.h"
typedef struct qspinlock arch_spinlock_t;
#line 687 "include/linux/list.h"
struct lockdep_map;
#line 127 "./arch/x86/include/uapi/asm/vm86.h"
struct kernel_vm86_regs {
   struct pt_regs pt ;
   unsigned short es ;
   unsigned short __esh ;
   unsigned short ds ;
   unsigned short __dsh ;
   unsigned short fs ;
   unsigned short __fsh ;
   unsigned short gs ;
   unsigned short __gsh ;
};
#line 79 "./arch/x86/include/asm/vm86.h"
union __anonunion____missing_field_name_15 {
   struct pt_regs *regs ;
   struct kernel_vm86_regs *vm86 ;
};
#line 79 "./arch/x86/include/asm/vm86.h"
struct math_emu_info {
   long ___orig_eip ;
   union __anonunion____missing_field_name_15 __annonCompField7 ;
};
#line 260 "./arch/x86/include/asm/special_insns.h"
struct fregs_state {
   u32 cwd ;
   u32 swd ;
   u32 twd ;
   u32 fip ;
   u32 fcs ;
   u32 foo ;
   u32 fos ;
   u32 st_space[20U] ;
   u32 status ;
};
#line 26 "./arch/x86/include/asm/fpu/types.h"
struct __anonstruct____missing_field_name_25 {
   u64 rip ;
   u64 rdp ;
};
#line 26 "./arch/x86/include/asm/fpu/types.h"
struct __anonstruct____missing_field_name_26 {
   u32 fip ;
   u32 fcs ;
   u32 foo ;
   u32 fos ;
};
#line 26 "./arch/x86/include/asm/fpu/types.h"
union __anonunion____missing_field_name_24 {
   struct __anonstruct____missing_field_name_25 __annonCompField11 ;
   struct __anonstruct____missing_field_name_26 __annonCompField12 ;
};
#line 26 "./arch/x86/include/asm/fpu/types.h"
union __anonunion____missing_field_name_27 {
   u32 padding1[12U] ;
   u32 sw_reserved[12U] ;
};
#line 26 "./arch/x86/include/asm/fpu/types.h"
struct fxregs_state {
   u16 cwd ;
   u16 swd ;
   u16 twd ;
   u16 fop ;
   union __anonunion____missing_field_name_24 __annonCompField13 ;
   u32 mxcsr ;
   u32 mxcsr_mask ;
   u32 st_space[32U] ;
   u32 xmm_space[64U] ;
   u32 padding[12U] ;
   union __anonunion____missing_field_name_27 __annonCompField14 ;
};
#line 66 "./arch/x86/include/asm/fpu/types.h"
struct swregs_state {
   u32 cwd ;
   u32 swd ;
   u32 twd ;
   u32 fip ;
   u32 fcs ;
   u32 foo ;
   u32 fos ;
   u32 st_space[20U] ;
   u8 ftop ;
   u8 changed ;
   u8 lookahead ;
   u8 no_update ;
   u8 rm ;
   u8 alimit ;
   struct math_emu_info *info ;
   u32 entry_eip ;
};
#line 155 "./arch/x86/include/asm/fpu/types.h"
struct xstate_header {
   u64 xfeatures ;
   u64 xcomp_bv ;
   u64 reserved[6U] ;
};
#line 161 "./arch/x86/include/asm/fpu/types.h"
struct xregs_state {
   struct fxregs_state i387 ;
   struct xstate_header header ;
   u8 __reserved[464U] ;
};
#line 179 "./arch/x86/include/asm/fpu/types.h"
union fpregs_state {
   struct fregs_state fsave ;
   struct fxregs_state fxsave ;
   struct swregs_state soft ;
   struct xregs_state xsave ;
};
#line 193 "./arch/x86/include/asm/fpu/types.h"
struct fpu {
   union fpregs_state state ;
   unsigned int last_cpu ;
   unsigned char fpstate_active ;
   unsigned char fpregs_active ;
   unsigned char counter ;
};
#line 213 "./arch/x86/include/asm/processor.h"
struct x86_hw_tss {
   u32 reserved1 ;
   u64 sp0 ;
   u64 sp1 ;
   u64 sp2 ;
   u64 reserved2 ;
   u64 ist[7U] ;
   u32 reserved3 ;
   u32 reserved4 ;
   u16 reserved5 ;
   u16 io_bitmap_base ;
};
#line 275 "./arch/x86/include/asm/processor.h"
struct tss_struct {
   struct x86_hw_tss x86_tss ;
   unsigned long io_bitmap[1025U] ;
   unsigned long SYSENTER_stack[64U] ;
};
#line 369
struct perf_event;
#line 370 "./arch/x86/include/asm/processor.h"
struct thread_struct {
   struct desc_struct tls_array[3U] ;
   unsigned long sp0 ;
   unsigned long sp ;
   unsigned short es ;
   unsigned short ds ;
   unsigned short fsindex ;
   unsigned short gsindex ;
   unsigned long fs ;
   unsigned long gs ;
   struct fpu fpu ;
   struct perf_event *ptrace_bps[4U] ;
   unsigned long debugreg6 ;
   unsigned long ptrace_dr7 ;
   unsigned long cr2 ;
   unsigned long trap_nr ;
   unsigned long error_code ;
   unsigned long *io_bitmap_ptr ;
   unsigned long iopl ;
   unsigned int io_bitmap_max ;
};
#line 55 "include/linux/debug_locks.h"
struct stack_trace {
   unsigned int nr_entries ;
   unsigned int max_entries ;
   unsigned long *entries ;
   int skip ;
};
#line 28 "include/linux/stacktrace.h"
struct lockdep_subclass_key {
   char __one_byte ;
};
#line 53 "include/linux/lockdep.h"
struct lock_class_key {
   struct lockdep_subclass_key subkeys[8U] ;
};
#line 59 "include/linux/lockdep.h"
struct lock_class {
   struct list_head hash_entry ;
   struct list_head lock_entry ;
   struct lockdep_subclass_key *key ;
   unsigned int subclass ;
   unsigned int dep_gen_id ;
   unsigned long usage_mask ;
   struct stack_trace usage_traces[13U] ;
   struct list_head locks_after ;
   struct list_head locks_before ;
   unsigned int version ;
   unsigned long ops ;
   char const   *name ;
   int name_version ;
   unsigned long contention_point[4U] ;
   unsigned long contending_point[4U] ;
};
#line 144 "include/linux/lockdep.h"
struct lockdep_map {
   struct lock_class_key *key ;
   struct lock_class *class_cache[2U] ;
   char const   *name ;
   int cpu ;
   unsigned long ip ;
};
#line 546 "include/linux/lockdep.h"
struct raw_spinlock {
   arch_spinlock_t raw_lock ;
   unsigned int magic ;
   unsigned int owner_cpu ;
   void *owner ;
   struct lockdep_map dep_map ;
};
#line 33 "include/linux/spinlock_types.h"
struct __anonstruct____missing_field_name_31 {
   u8 __padding[24U] ;
   struct lockdep_map dep_map ;
};
#line 33 "include/linux/spinlock_types.h"
union __anonunion____missing_field_name_30 {
   struct raw_spinlock rlock ;
   struct __anonstruct____missing_field_name_31 __annonCompField16 ;
};
#line 33 "include/linux/spinlock_types.h"
struct spinlock {
   union __anonunion____missing_field_name_30 __annonCompField17 ;
};
#line 76 "include/linux/spinlock_types.h"
typedef struct spinlock spinlock_t;
#line 39 "include/linux/osq_lock.h"
struct mutex {
   atomic_t count ;
   spinlock_t wait_lock ;
   struct list_head wait_list ;
   struct task_struct *owner ;
   void *magic ;
   struct lockdep_map dep_map ;
};
#line 15 "./arch/x86/include/asm/tsc.h"
typedef unsigned long long cycles_t;
#line 240 "include/linux/timer.h"
struct rb_node {
   unsigned long __rb_parent_color ;
   struct rb_node *rb_right ;
   struct rb_node *rb_left ;
};
#line 41 "include/linux/rbtree.h"
struct rb_root {
   struct rb_node *rb_node ;
};
#line 712 "include/linux/module.h"
struct interval_tree_node {
   struct rb_node rb ;
   unsigned long start ;
   unsigned long last ;
   unsigned long __subtree_last ;
};
#line 41 "include/linux/random.h"
struct rnd_state {
   __u32 s1 ;
   __u32 s2 ;
   __u32 s3 ;
   __u32 s4 ;
};
#line 29 "include/linux/types.h"
typedef _Bool bool;
#line 1 "<compiler builtins>"
__inline static long ldv__builtin_expect(long exp , long c ) ;
#line 368 "./arch/x86/include/asm/paravirt_types.h"
extern struct pv_cpu_ops pv_cpu_ops ;
#line 142 "include/linux/printk.h"
extern int printk(char const   *  , ...) ;
#line 177 "./arch/x86/include/asm/paravirt.h"
__inline static u64 paravirt_read_tsc(void) 
{ 
  u64 __ret ;
  unsigned long __edi ;
  unsigned long __esi ;
  unsigned long __edx ;
  unsigned long __ecx ;
  unsigned long __eax ;
  long tmp ;

  {
#line 179
  __edi = __edi;
#line 179
  __esi = __esi;
#line 179
  __edx = __edx;
#line 179
  __ecx = __ecx;
#line 179
  __eax = __eax;
#line 179
  tmp = ldv__builtin_expect((unsigned long )pv_cpu_ops.read_tsc == (unsigned long )((u64 (*)(void))0),
                         0L);
#line 179
  if (tmp != 0L) {
#line 179
    __asm__  volatile   ("1:\tud2\n.pushsection __bug_table,\"a\"\n2:\t.long 1b - 2b, %c0 - 2b\n\t.word %c1, 0\n\t.org 2b+%c2\n.popsection": : "i" ((char *)"./arch/x86/include/asm/paravirt.h"),
                         "i" (179), "i" (12UL));
    ldv_4012: ;
#line 179
    goto ldv_4012;
  } else {

  }
#line 179
  __asm__  volatile   ("771:\n\tcall *%c6;\n772:\n.pushsection .parainstructions,\"a\"\n .balign 8 \n .quad  771b\n  .byte %c5\n  .byte 772b-771b\n  .short %c7\n.popsection\n": "=D" (__edi),
                       "=S" (__esi), "=d" (__edx), "=c" (__ecx), "=a" (__eax): [paravirt_typenum] "i" (34UL),
                       [paravirt_opptr] "i" (& pv_cpu_ops.read_tsc), [paravirt_clobber] "i" (511): "memory",
                       "cc", "r8", "r9", "r10", "r11");
#line 179
  __ret = (unsigned long long )__eax;
#line 179
  return (__ret);
}
}
#line 18 "include/linux/math64.h"
__inline static u64 div_u64_rem(u64 dividend , u32 divisor , u32 *remainder ) 
{ 


  {
#line 20
  *remainder = (u32 )(dividend % (u64 )divisor);
#line 21
  return (dividend / (u64 )divisor);
}
}
#line 97 "include/linux/math64.h"
__inline static u64 div_u64(u64 dividend , u32 divisor ) 
{ 
  u32 remainder ;
  u64 tmp ;

  {
#line 100
  tmp = div_u64_rem(dividend, divisor, & remainder);
#line 100
  return (tmp);
}
}
#line 174 "include/linux/mutex.h"
extern void mutex_unlock(struct mutex * ) ;
#line 177
void ldv_mutex_unlock_6(struct mutex *ldv_func_arg1 ) ;
#line 50 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static long ldv__builtin_expect(long exp , long c ) 
{ 


  {
#line 52
  return (exp);
}
}
#line 18 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.o.c.prepared"
extern void mutex_lock(struct mutex * ) ;
#line 21
void ldv_mutex_lock_5(struct mutex *ldv_func_arg1 ) ;
#line 26
void ldv_mutex_lock_lock(struct mutex *lock ) ;
#line 30
void ldv_mutex_unlock_lock(struct mutex *lock ) ;
#line 22 "./arch/x86/include/asm/tsc.h"
__inline static cycles_t get_cycles(void) 
{ 
  unsigned long long ret ;

  {
#line 24
  ret = 0ULL;
#line 30
  ret = paravirt_read_tsc();
#line 32
  return (ret);
}
}
#line 14 "include/linux/interval_tree.h"
extern void interval_tree_insert(struct interval_tree_node * , struct rb_root * ) ;
#line 17
extern void interval_tree_remove(struct interval_tree_node * , struct rb_root * ) ;
#line 20
extern struct interval_tree_node *interval_tree_iter_first(struct rb_root * , unsigned long  ,
                                                           unsigned long  ) ;
#line 24
extern struct interval_tree_node *interval_tree_iter_next(struct interval_tree_node * ,
                                                          unsigned long  , unsigned long  ) ;
#line 46 "include/linux/random.h"
extern u32 prandom_u32_state(struct rnd_state * ) ;
#line 69 "include/linux/random.h"
__inline static u32 __seed(u32 x , u32 m ) 
{ 


  {
#line 71
  return (x < m ? x + m : x);
}
}
#line 79 "include/linux/random.h"
__inline static void prandom_seed_state(struct rnd_state *state , u64 seed ) 
{ 
  u32 i ;

  {
#line 81
  i = ((u32 )(seed >> 32) ^ ((u32 )seed << 10U)) ^ (u32 )seed;
#line 83
  state->s1 = __seed(i, 2U);
#line 84
  state->s2 = __seed(i, 8U);
#line 85
  state->s3 = __seed(i, 16U);
#line 86
  state->s4 = __seed(i, 128U);
#line 87
  return;
}
}
#line 12 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.c"
static struct rb_root root  =    {(struct rb_node *)0};
#line 13 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.c"
static struct interval_tree_node nodes[100U]  ;
#line 14 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.c"
static u32 queries[100U]  ;
#line 16 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.c"
static struct rnd_state rnd  ;
#line 19 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.c"
__inline static unsigned long search(unsigned long query , struct rb_root *root___0 ) 
{ 
  struct interval_tree_node *node ;
  unsigned long results ;

  {
#line 22
  results = 0UL;
#line 24
  node = interval_tree_iter_first(root___0, query, query);
#line 24
  goto ldv_16025;
  ldv_16024: 
#line 26
  results = results + 1UL;
#line 25
  node = interval_tree_iter_next(node, query, query);
  ldv_16025: ;
#line 24
  if ((unsigned long )node != (unsigned long )((struct interval_tree_node *)0)) {
#line 26
    goto ldv_16024;
  } else {

  }

#line 27
  return (results);
}
}
#line 30 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.c"
static void init(void) 
{ 
  int i ;
  u32 a ;
  u32 tmp ;
  u32 b ;
  u32 tmp___0 ;

  {
#line 33
  i = 0;
#line 33
  goto ldv_16034;
  ldv_16033: 
#line 34
  tmp = prandom_u32_state(& rnd);
#line 34
  a = tmp;
#line 35
  tmp___0 = prandom_u32_state(& rnd);
#line 35
  b = tmp___0;
#line 36
  if (a <= b) {
#line 37
    nodes[i].start = (unsigned long )a;
#line 38
    nodes[i].last = (unsigned long )b;
  } else {
#line 40
    nodes[i].start = (unsigned long )b;
#line 41
    nodes[i].last = (unsigned long )a;
  }
#line 33
  i = i + 1;
  ldv_16034: ;
#line 33
  if (i <= 99) {
#line 35
    goto ldv_16033;
  } else {

  }
#line 44
  i = 0;
#line 44
  goto ldv_16037;
  ldv_16036: 
#line 45
  queries[i] = prandom_u32_state(& rnd);
#line 44
  i = i + 1;
  ldv_16037: ;
#line 44
  if (i <= 99) {
#line 46
    goto ldv_16036;
  } else {

  }

#line 51
  return;
}
}
#line 48 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.c"
static int interval_tree_test_init(void) 
{ 
  int i ;
  int j ;
  unsigned long results ;
  cycles_t time1 ;
  cycles_t time2 ;
  cycles_t time ;
  unsigned long tmp ;
  u64 tmp___0 ;

  {
#line 54
  printk("\tinterval tree insert/remove");
#line 56
  prandom_seed_state(& rnd, 3141592653589793238ULL);
#line 57
  init();
#line 59
  time1 = get_cycles();
#line 61
  i = 0;
#line 61
  goto ldv_16055;
  ldv_16054: 
#line 62
  j = 0;
#line 62
  goto ldv_16049;
  ldv_16048: 
#line 63
  interval_tree_insert((struct interval_tree_node *)(& nodes) + (unsigned long )j,
                       & root);
#line 62
  j = j + 1;
  ldv_16049: ;
#line 62
  if (j <= 99) {
#line 64
    goto ldv_16048;
  } else {

  }
#line 64
  j = 0;
#line 64
  goto ldv_16052;
  ldv_16051: 
#line 65
  interval_tree_remove((struct interval_tree_node *)(& nodes) + (unsigned long )j,
                       & root);
#line 64
  j = j + 1;
  ldv_16052: ;
#line 64
  if (j <= 99) {
#line 66
    goto ldv_16051;
  } else {

  }
#line 61
  i = i + 1;
  ldv_16055: ;
#line 61
  if (i <= 99999) {
#line 63
    goto ldv_16054;
  } else {

  }
#line 68
  time2 = get_cycles();
#line 69
  time = time2 - time1;
#line 71
  time = div_u64(time, 100000U);
#line 72
  printk(" -> %llu cycles\n", time);
#line 74
  printk("\tinterval tree search");
#line 76
  j = 0;
#line 76
  goto ldv_16058;
  ldv_16057: 
#line 77
  interval_tree_insert((struct interval_tree_node *)(& nodes) + (unsigned long )j,
                       & root);
#line 76
  j = j + 1;
  ldv_16058: ;
#line 76
  if (j <= 99) {
#line 78
    goto ldv_16057;
  } else {

  }
#line 79
  time1 = get_cycles();
#line 81
  results = 0UL;
#line 82
  i = 0;
#line 82
  goto ldv_16064;
  ldv_16063: 
#line 83
  j = 0;
#line 83
  goto ldv_16061;
  ldv_16060: 
#line 84
  tmp = search((unsigned long )queries[j], & root);
#line 84
  results = tmp + results;
#line 83
  j = j + 1;
  ldv_16061: ;
#line 83
  if (j <= 99) {
#line 85
    goto ldv_16060;
  } else {

  }
#line 82
  i = i + 1;
  ldv_16064: ;
#line 82
  if (i <= 9999) {
#line 84
    goto ldv_16063;
  } else {

  }
#line 86
  time2 = get_cycles();
#line 87
  time = time2 - time1;
#line 89
  time = div_u64(time, 10000U);
#line 90
  tmp___0 = div_u64((u64 )results, 10000U);
#line 90
  results = (unsigned long )tmp___0;
#line 91
  printk(" -> %llu cycles (%lu results)\n", time, results);
#line 94
  return (-11);
}
}
#line 97 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.c"
static void interval_tree_test_exit(void) 
{ 


  {
#line 99
  printk("\ttest exit\n");
#line 100
  return;
}
}
#line 125
void ldv_check_final_state(void) ;
#line 134
extern void ldv_initialize(void) ;
#line 137
extern void ldv_handler_precall(void) ;
#line 140
extern int nondet_int(void) ;
#line 143 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.c"
int LDV_IN_INTERRUPT  ;
#line 146 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.c"
void main(void) 
{ 
  int tmp ;
  int tmp___0 ;
  int tmp___1 ;

  {
#line 158
  LDV_IN_INTERRUPT = 1;
#line 167
  ldv_initialize();
#line 178
  ldv_handler_precall();
#line 179
  tmp = interval_tree_test_init();
#line 179
  if (tmp != 0) {
#line 180
    goto ldv_final;
  } else {

  }
#line 182
  goto ldv_16102;
  ldv_16101: 
#line 185
  tmp___0 = nondet_int();
#line 185
  switch (tmp___0) {
  default: ;
#line 187
  goto ldv_16100;
  }
  ldv_16100: ;
  ldv_16102: 
#line 182
  tmp___1 = nondet_int();
#line 182
  if (tmp___1 != 0) {
#line 184
    goto ldv_16101;
  } else {

  }

#line 204
  ldv_handler_precall();
#line 205
  interval_tree_test_exit();
  ldv_final: 
#line 208
  ldv_check_final_state();
#line 211
  return;
}
}
#line 57 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.o.c.prepared"
void ldv_mutex_lock_5(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 60
  ldv_mutex_lock_lock(ldv_func_arg1);
#line 62
  mutex_lock(ldv_func_arg1);
#line 63
  return;
}
}
#line 65 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/dscv/ri/32_7a/lib/interval_tree_test.o.c.prepared"
void ldv_mutex_unlock_6(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 68
  ldv_mutex_unlock_lock(ldv_func_arg1);
#line 70
  mutex_unlock(ldv_func_arg1);
#line 71
  return;
}
}
#line 10 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static void ldv_error(void) 
{ 


  {
  ERROR: ;
#line 12
  goto ERROR;
}
}
#line 20 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static void ldv_stop(void) 
{ 


  {
  LDV_STOP: ;
#line 21
  goto LDV_STOP;
}
}
#line 25
extern int ldv_undef_int(void) ;
#line 30 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static int ldv_undef_int_negative(void) 
{ 
  int ret ;
  int tmp ;

  {
#line 32
  tmp = ldv_undef_int();
#line 32
  ret = tmp;
#line 34
  if (ret >= 0) {
#line 34
    ldv_stop();
  } else {

  }
#line 36
  return (ret);
}
}
#line 7 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err(void const   *ptr ) 
{ 


  {
#line 10
  return ((unsigned long )ptr > 2012UL);
}
}
#line 14 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
void *ldv_err_ptr(long error ) 
{ 


  {
#line 17
  return ((void *)(2012L - error));
}
}
#line 21 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
long ldv_ptr_err(void const   *ptr ) 
{ 


  {
#line 24
  return ((long )(2012UL - (unsigned long )ptr));
}
}
#line 28 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err_or_null(void const   *ptr ) 
{ 
  bool tmp ;
  int tmp___0 ;

  {
#line 31
  if ((unsigned long )ptr == (unsigned long )((void const   *)0)) {
#line 31
    tmp___0 = 1;
  } else {
#line 31
    tmp = ldv_is_err(ptr);
#line 31
    if ((int )tmp) {
#line 31
      tmp___0 = 1;
    } else {
#line 31
      tmp___0 = 0;
    }
  }
#line 31
  return ((bool )tmp___0);
}
}
#line 8 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
static int ldv_mutex_lock  =    1;
#line 11 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_interruptible_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 16
  if (ldv_mutex_lock != 1) {
#line 16
    ldv_error();
  } else {

  }
#line 19
  nondetermined = ldv_undef_int();
#line 22
  if (nondetermined != 0) {
#line 25
    ldv_mutex_lock = 2;
#line 27
    return (0);
  } else {
#line 32
    return (-4);
  }
}
}
#line 37 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_killable_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 42
  if (ldv_mutex_lock != 1) {
#line 42
    ldv_error();
  } else {

  }
#line 45
  nondetermined = ldv_undef_int();
#line 48
  if (nondetermined != 0) {
#line 51
    ldv_mutex_lock = 2;
#line 53
    return (0);
  } else {
#line 58
    return (-4);
  }
}
}
#line 63 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_lock_lock(struct mutex *lock ) 
{ 


  {
#line 66
  if (ldv_mutex_lock != 1) {
#line 66
    ldv_error();
  } else {

  }
#line 68
  ldv_mutex_lock = 2;
#line 69
  return;
}
}
#line 72 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_trylock_lock(struct mutex *lock ) 
{ 
  int is_mutex_held_by_another_thread ;

  {
#line 77
  if (ldv_mutex_lock != 1) {
#line 77
    ldv_error();
  } else {

  }
#line 80
  is_mutex_held_by_another_thread = ldv_undef_int();
#line 83
  if (is_mutex_held_by_another_thread != 0) {
#line 86
    return (0);
  } else {
#line 91
    ldv_mutex_lock = 2;
#line 93
    return (1);
  }
}
}
#line 98 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_atomic_dec_and_mutex_lock_lock(atomic_t *cnt , struct mutex *lock ) 
{ 
  int atomic_value_after_dec ;

  {
#line 103
  if (ldv_mutex_lock != 1) {
#line 103
    ldv_error();
  } else {

  }
#line 106
  atomic_value_after_dec = ldv_undef_int();
#line 109
  if (atomic_value_after_dec == 0) {
#line 112
    ldv_mutex_lock = 2;
#line 114
    return (1);
  } else {

  }
#line 118
  return (0);
}
}
#line 123 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_is_locked_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 127
  if (ldv_mutex_lock == 1) {
#line 130
    nondetermined = ldv_undef_int();
#line 133
    if (nondetermined != 0) {
#line 136
      return (0);
    } else {
#line 141
      return (1);
    }
  } else {
#line 147
    return (1);
  }
}
}
#line 152 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_unlock_lock(struct mutex *lock ) 
{ 


  {
#line 155
  if (ldv_mutex_lock != 2) {
#line 155
    ldv_error();
  } else {

  }
#line 157
  ldv_mutex_lock = 1;
#line 158
  return;
}
}
#line 163 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_lock_device_lock(void) 
{ 


  {
#line 166
  ldv_mutex_lock_lock((struct mutex *)0);
#line 167
  return;
}
}
#line 170 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_trylock_device_lock(void) 
{ 
  int tmp ;

  {
#line 172
  tmp = ldv_mutex_trylock_lock((struct mutex *)0);
#line 172
  return (tmp);
}
}
#line 176 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_lock_device_for_reset_lock(void) 
{ 
  int tmp ;
  int tmp___0 ;

  {
#line 178
  tmp___0 = ldv_undef_int();
#line 178
  if (tmp___0 != 0) {
#line 180
    ldv_mutex_lock_lock((struct mutex *)0);
#line 182
    return (0);
  } else {
#line 185
    tmp = ldv_undef_int_negative();
#line 185
    return (tmp);
  }
}
}
#line 189 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_unlock_device_lock(void) 
{ 


  {
#line 191
  ldv_mutex_unlock_lock((struct mutex *)0);
#line 192
  return;
}
}
#line 196 "/home/cluser/mutilin/launch/work/current--X--lib--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/102/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_check_final_state(void) 
{ 


  {
#line 199
  if (ldv_mutex_lock != 1) {
#line 199
    ldv_error();
  } else {

  }
#line 203
  return;
}
}
